c
c
      implicit double precision(a-b, d-h, o-z)
      implicit integer (i-n)
	implicit double complex (c)
c
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
c
	dimension datai(10000)
	dimension thickl(60), rho(60), vel(60), hh(60)
c
c
	open ( 8, file = 'mrt-el.idt')
	open ( 9, file = 'mrt-el.odt')
      open (11, file = 'Acci-el.frd')
      open (12, file = 'Ampo-el.frd')
c
c
      refhed = 1.d0
      budwat = 1.d0
      graacc = 1.d0
c
c
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
      pi = 4.d0 * datan(1.d0)
c
c
      ndat=2**16
	nlayer=20
c
c
      call inpdat(datai, thickl, rho, vel, hh)
	call solve (datai, thickl, rho, vel, hh)
c
c
	close (8)
      close (9)
      close (11)
      close (12)
c
c
      stop 7777
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   I N P D A T             **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine inpdat(datai, thickl, rho, vel, hh)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*50 dataname, dline
	character*8 frag
	character*5 fragname
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
      dimension datai(ndat)
	dimension thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Input Data of Acc. Measured or Stress Wave Analyzed
c----------------------------------------------------------------------
c
c
c
	rewind(8)
	rewind(9)
c
c
c
c     /const/
c
  100	read (8,8000,end=999, err=999) frag
 8000	format(a7)
      if (frag .ne. '/const/') goto 100
	    read (8,8100) dline
 8100	    format(a5)
	    read (8,*) graacc, budwat, refhed
c
	    write (9,9100)
 9100	    format('/const/')
	    write (9,9110)
 9110	    format('     graacc          budwat          refhed')
	    write (9,9120) graacc, budwat, refhed
 9120	    format(3e15.7)
	rewind(8)
c
c     /dainf/
c
  200	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/dainf/') goto 200
	    read (8,8100) dline
	    read (8,*) ndat
c
	    write (9,9200)
 9200	    format('/dainf/')
	    write (9,9210)
 9210	    format('     ndat')
	    write (9,9220) ndat
 9220	    format(9x, i6)
	rewind(8)
c
c     /tcinf/
c
  300	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/tcinf/') goto 300
	    read (8,8100) dline
	    read (8,*) tint, tskp
c
	    write (9,9300)
 9300	    format('/tcinf/')
	    write (9,9310)
 9310	    format('     tint[sec.]      tskp[sec.]')
	    write (9,9320) tint, tskp
 9320	    format(2e15.7)
	rewind(8)
c
c     /niinf/
c
  600	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/niinf/') goto 600
	    read (8,8100) dline
	    read (8,*) gammanew, betanew
c
	    write (9,9600)
 9600	    format('/niinf/')
	    write (9,9610)
 9610	    format('     gamma           beta')
	    write (9,9620) gammanew, betanew
 9620	    format(2e15.7)
	rewind(8)
c
c     /flinf/
c
  700	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/flinf/') goto 700
	    read (8,8100) dline
	    read (8,*) ifinp
	    read (8,8100) dline
	    read (8,*) band, offlow, offhigh
c
	    write (9,9700)
 9700	    format('/flinf/')
	    write (9,9710)
 9710	    format('     ifinp     ')
	    write (9,9720) ifinp
 9720	    format(9x, i6)
	    write (9,9730)
 9730	    format('     band[Hz]        lowcut[Hz]      highcut[Hz]')
	    write (9,9740) band, offlow, offhigh
 9740	    format(3e15.7)
	rewind(8)
c
c     /file_frag/
c
  800	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/file_f') goto 800
	    read (8,8100) dline
	    read (8,*) inpw
	    if (inpw .le. 0) goto 900
	    read (8,8100) dline
	    read (8,9820) dataname
	    read (8,8100) dline
	    read (8,9840) fragname
c
	    write (9,9800)
 9800	    format('/file_frag/')
	    write (9,9810)
 9810	    format('     data filename[in 15 letters including symbols]')
	    write (9,9820) dataname
 9820	    format(15x, a30)
	    write (9,9830)
 9830	    format('     frag name[in 5 letters including symbols]')
	    write (9,9840) fragname
 9840	    format(15x, a5)
	rewind(8)
c
c     /layinf/
c
  900	read (8,8000,end=999, err=999) frag
	if (frag .ne. '/lyinf/') goto 900
	    read (8,8100) dline
	    read (8,*) nlayer
	    read (8,8100) dline
	    do 910 i=1, nlayer
	        read (8,*) j, thickl(j), rho(j), g, hh(j)
	        vel(j)=dsqrt(g/rho(j))
  910     continue
c
	    write (9,9900)
 9900	    format('/layinf/')
	    write (9,9910)
 9910	    format('   No.   thickl         rho            vel        hh')
          do 920 i=1, nlayer
	        write (9,9920) i, thickl(i), rho(i), vel(i), hh(i) 
 9920	        format(i5, 4e15.7)
  920     continue
	rewind(8)
c
c
c
c        / Read Data /
c
	if (inpw .lt. 0) goto 777
c
	call readdat(dataname, fragname, datai)
c
c
  777 return
c
c
  999	write(*, 9999) 
 9999 format(' / There are not some frags in IDT-file /')
	stop 9999
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   R E A D D A T           **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine readdat(dataname, fragname, datai)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*5 fragname, frag
	character*50 dataname
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
      dimension datai(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Input Data of Acc. Measured or Stress Wave Analyzed
c----------------------------------------------------------------------
c
c
	open (10, file = dataname)
c
c
      ndat = 0
c
c        / Read Data /
c
  100	read (10, 1000) frag
 1000	format(a5)
	if (frag .ne. fragname) goto 100
c
  200 read (10,*, end=300, err=999) dummy
	backspace(10)
      ndat=ndat+1
	datai(ndat)=0.d0
	read (10,*) datai(ndat)
	goto 200
  300 ndat=ndat
      if (ndat .eq. 0) goto 555
c
c
	close(10)
c
c        / Arrangement of Number of Data to be Power of 2/
c
      i=0
  400 i=i+1
      ndummy=ndat-2**i
      if (ndummy .gt. 0) then
          goto 400
      else if (ndummy .lt. 0) then
          ndummy=iabs(ndummy)
          do 500 j=ndat+1, ndat+ndummy
              datai(j)=0.d0
  500     continue
	    ndat=ndat+ndummy
	    goto 777
      else
          ndat=ndat
      end if
c
c
  777 return
c
c
  555 write (11,1100)
      write(*,1100)
 1100 format('** Frag do not exit or Data do not exit **')
	close(10)
      stop 5555
c
c
  999 write (11,1110)
      write(*,1100)
 1110 format('** Read error occurs **')
	close(10)
     	stop 9999
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   S O L V E               **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine solve(datai, thickl, rho, vel, hh)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c)
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
	dimension datai(ndat) 
	dimension thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
	dimension acci(ndat)
	dimension amp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Main Routine to Solve
c----------------------------------------------------------------------
c
c     / Filteration of Acc. with Spectrum Windows
c
      if (ifinp .gt. 0) call fft_filter(datai)
  	do 200 i=1, ndat
	    acci(i)=datai(i)
  200	continue
c
c
c      / Vibration Behaviors of Base /
c
      call opt_fft_dat(acci, amp)
c
c     / Reflection Response of Surface Layer
c
      if (inpw .lt. 0) then
          do 300 i=1, ndat/2+1
              amp(i)=1.d0 
  300     continue
	end if
c
      call mrt_solve(amp, thickl, rho, vel, hh)
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   F F T _ F I L T E R     **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine fft_filter(x)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
	dimension cdat(ndat)
      dimension amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
	dimension x(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Fast Fourier Transform with Spectrum Window Filter
c----------------------------------------------------------------------
c
c
      call fftc(x, cdat, -1)
	call freqpass(cdat)
      call ampphs(cdat, amp, famp, pamp, phase)
	call swin(famp, pamp, 110)
	call filterc(famp, cdat)
      call fftc(x, cdat, 1)
	do 100 i=1, ndat
	    x(i)=dble(cdat(i))
  100	continue
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   O P T _ F F T _ D A T   **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine opt_fft_dat(x, amp)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
	dimension cdat(ndat), nmpeak(2)
      dimension amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
	dimension x(ndat), y(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Output fast fourier transformed data
c----------------------------------------------------------------------
c
c
      call fft_filter(x)
      call fftc(x, cdat, -1)
      call ampphs(cdat, amp, famp, pamp, phase)
      call msg_name_col
	call opt_fft_frd(amp, famp, pamp, phase)
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   F F T C                 **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine fftc(xx, cdat, invt)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension xx(ndat), cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Fast Fourier Transform Convertion
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat
	    if (invt .gt. 0) then 
            cdat(i)=cdat(i)
	    else
	      cdat(i)=cmplx(xx(i), 0.d0)
	    end if
  100 continue
c
  200 call fast(cdat, invt)
      if (invt .gt. 0) goto 777
      do 300 i=1, ndat
          cdat(i)=cdat(i)/dble(ndat)
  300 continue
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   F A S T                 **********
c*                                                                     *
c***********************************************************************
c
      subroutine fast(cdat, invt)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat, ctemp, ctheta
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Fast Fourier Transform
c----------------------------------------------------------------------
c
c
      j=1
      do 140 i=1, ndat
        if (i .ge. j) goto 110
          ctemp=cdat(j)
          cdat(j)=cdat(i)
          cdat(i)=ctemp
  110 m=ndat/2
  120 if (j .le. m) goto 130
      j=j-m
      m=m/2
      if (m .ge. 2) goto 120
  130 j=j+m
  140 continue
      kmax=1
  150 if (kmax .ge. ndat) goto 777
      istep=kmax*2
      do 170 k=1, kmax
        ctheta=cmplx(0.d0, pi*dble(invt*(k-1))/dble(kmax))
        do 160 i=k,ndat,istep
          j=i+kmax
          ctemp=cdat(j)*cdexp(ctheta)
		cdat(j)=cdat(i)-ctemp
          cdat(i)=cdat(i)+ctemp
  160   continue
  170 continue
      kmax=istep
      goto 150
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    A M P P H S            **********
c*                                                                     *
c***********************************************************************
c
      subroutine ampphs(cdat, amp, famp, pamp, phase)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension cdat(ndat), amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Amplitudes and Phase for Fourier Series 
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat/2+1
c
          amp(i)=cdabs(cdat(i))*2.d0
	    famp(i)=cdabs(cdat(i))*(dble(ndat)*tint)
  	    if ((i .eq. 1) .or. (i .eq. ndat/2+1))then
	    	pamp(i)=     famp(i)*famp(i)/(dble(ndat)*tint)
	    else
		   	pamp(i)=2.d0*famp(i)*famp(i)/(dble(ndat)*tint)
	    end if 
c
	    phase(i)=0.d0 
          xcphs =   2.d0*dble(cdat(i))
          xsphs = - 2.d0*aimag(cdat(i))
	    if ((dabs(xcphs) .eq. 0.d0) .and. 
     *	      (dabs(xsphs) .eq. 0.d0)) goto 100
            if (dabs(xcphs) .ge. dabs(xsphs)) then
              if (xcphs .ge. 0.d0) then
                phase(i)=datan(-xsphs/xcphs)
              else
                phase(i)=datan(-xsphs/xcphs)+pi
              end if
            else
              if (xsphs .ge. 0.d0) then
                phase(i)=pi/2.d0-datan(-xcphs/xsphs)
              else
                phase(i)=pi/2.d0-datan(-xcphs/xsphs)+pi
            end	if
          end if
          phase(i)=dmod(phase(i)+2.d0*pi, 2.d0*pi)-2.d0*pi
c
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    F R E Q P A S S        **********
c*                                                                     *
c***********************************************************************
c
      subroutine freqpass(cdat)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Low or high Pass Filter to cut off frequency 
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat/2+1
	    if (dble(i)/(tint*dble(ndat)) .gt. offhigh) then
			cdat(i)=dcmplx(0.d0, 0.d0)
		end if
	    if (dble(i)/(tint*dble(ndat)) .lt. offlow) then
			cdat(i)=dcmplx(0.d0, 0.d0)
		end if
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    S W I N                **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine swin(famp, pamp, ind)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension famp(ndat/2+1), pamp(ndat/2+1)
	dimension w(101), g1(ndat), g2(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     Smoothed Spectra by Parzen's Spectral Windows
c
c----------------------------------------------------------------------
c
c	  Initialization
c
	do 10 i=1, 101
          w(i)=0.d0
   10	continue
      do 20 i=1, ndat
	    g1(i)=0.d0
	    g2(i)=0.d0
   20	continue
c
	nfold=ndat/2+1
	df=1.d0/(dble(ndat)*tint)
c
      t=1.d0/df
	if (band .eq. 0.d0) goto 120
	    udf=1.854305/band*df
	if (udf .gt. 0.5d0) goto 230 
	    lmax=idint(2.d0/udf)+1 
      if (lmax. gt. 101) goto 240
c
c     Spectral Window
c
      w(1)=3.d0/4.d0*udf
	do 110 l=2, lmax
	    dif=1.570796*dble(l-1)*udf
	    w(l)=w(1)*(dsin(dif)/dif)**4.d0
  110	continue
c
c	Conversion from Fourier to Power Spectrum 
c
  120	if (ind .ne. 100) goto 140
      pamp(1)=famp(1)*famp(1)/t
      do 130 k=2, nfold-1
	   	pamp(k)=2.d0*famp(k)*famp(k)/t
  130 continue
      pamp(nfold)=famp(nfold)*famp(nfold)/t
c
c	Smoothing of Power Spectrum
c
  140 if (band .eq. 0.d0) goto 210
	ll=lmax*2-1
	ln=ll-1+nfold
	lt=(ll-1)*2+nfold
	le=lt-lmax+1
	do 150 k=1, lt
	    g1(k)=0.d0
  150	continue
	do 160 k=1, nfold
	    g1(ll-1+k)=pamp(k)
  160	continue
	do 180 k=lmax, le
	    s=w(1)*g1(k)
	    do 170 l=2, lmax
              s=s+w(l)*(g1(k-l+1)+g1(k+l-1))    
  170     continue
          g2(k)=s
  180	continue
 	do 190 l=2, lmax 
 	    g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1) 
	    g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
  190 continue
	do 200 k=1, nfold
	    pamp(k)=g2(ll-1+k)
  200 continue
c
c	Smoothed Fourier Spectrum
c
  210 famp(1)=dsqrt(pamp(1)*t)
	do 220 k=2, nfold-1
	    famp(k)=dsqrt(pamp(k)*t/2.d0)
  220 continue
	famp(nfold)=dsqrt(pamp(nfold)*t)
c
	return
c
c
  230 write(*,601)
	stop
  240 write(*,602)
	stop
c
c	Format Statements
c
  601 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO NARROW')
  602 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO WIDE')
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    F I L T E R C          **********
c*                                                                     *
c***********************************************************************
c
      subroutine filterc(famp, cx)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
	dimension famp(ndat/2+1), cx(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Frequency range data
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat
	    freq=dble(i)/(dble(ndat)*tint)
	    if (i .le. (ndat/2+1)) then
	        j=i
	        if ((freq .lt. offlow) .or. (freq .gt. offhigh)) then
				cx(i)=0.d0
	            goto 100
              end if
	    else
	        j=ndat-i+2
	    end if
	    if (cdabs(cx(i)) .eq. 0.d0) goto 100
	    cx(i)=cx(i)*famp(j)/(dble(ndat)*tint)/cdabs(cx(i))
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    O P T F R D            **********
c*                                                                     *
c***********************************************************************
c
      subroutine opt_fft_frd(amp, famp, pamp, phase)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
	common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /lyinf/ nlayer
c
      dimension amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Output of Frequency Range Data
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat/2+1
	    freq=dble(i)/(dble(ndat)*tint)
          write (11, 1100) i,freq, 1.d0/freq , amp(i), 
     *                     famp(i), pamp(i), phase(i)
 1100	    format(i5, ', ', 5(e15.7, ', '), e15.7)
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    M S G N C V            **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine msg_name_col
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
c
      common /const/ graacc, budwat, refhed
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Message of names of columed variables
c----------------------------------------------------------------------
c
c
      write (11, 1100)
 1100 format('  No., Freq., Period., Amp., F.Amp., P.Amp., Phase')
c
c
      return
c
c
      end
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   M R T _ S O L V E       **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine mrt_solve(amp, thickl, rho, vel, hh)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c)
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
	dimension  cmatrix_r(nlayer-1,2,2)
	dimension  amp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Main Routine for MRT
c----------------------------------------------------------------------
c
c
	omega_nat1=pi*vel(1)/(2.d0*thickl(1))
c
      call opt_msg(thickl,rho,vel,hh)
c
	do 100 i=1, ndat/2+1
	   freq=dble(i)/(dble(ndat)*tint)
         omega=2.d0*pi*freq
	   accb=amp(i)
         call set_matrix(omega,thickl,rho,vel,hh,cmatrix_r)
 	   call opt_dat(omega,thickl,vel,cmatrix_r, accb)
  100	continue
c
c
  777 return
c
c
      end
c
c
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   S E T_ M A T R I X      **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine set_matrix(omega, thickl, rho, vel, hh, cmatrix_r)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c)
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
	dimension  cmatrix_t(nlayer-1,2,2), cmatrix_q(nlayer-1,2,2)
	dimension  cmatrix_r(nlayer-1,2,2)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Set Matrix
c----------------------------------------------------------------------
c
c
      call matrix_t(omega, thickl, rho, vel, hh, cmatrix_t)
	do 100 i=1, nlayer-1
	    nolayer=i+1
	    call matrix_q(nolayer, cmatrix_t, cmatrix_q)
	    call matrix_r(nolayer, cmatrix_q, cmatrix_r)
  100	continue
c
c
  777 return
c
c
      end
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   M A T R I X _ T         **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine matrix_t(omega, thickl, rho, vel, hh, cmatrix_t)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
	dimension  cmatrix_t(nlayer-1,2,2), cthickl(nlayer)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Response of Amplitude of Multi-Layer 
c----------------------------------------------------------------------
c
c
c
	cr1=dcmplx(1.d0, 0.d0)
	cr2=dcmplx(2.d0, 0.d0)
	ci1=dcmplx(0.d0, 1.d0)
c
c
	do 100 i=1, nlayer-1
	   do 200 j=1,2
	      do 300 k=1,2
	        cmatrix_t(i,j,k)=0.d0 
  300	      continue
  200    continue
  100 continue 	   
c
c
c
c
	do 400 i=1, nlayer-1
	    cthickl(i)=dcmplx(thickl(i), 0.d0)
	    crho1=dcmplx(rho(i), 0.d0)
	    crho2=dcmplx(rho(i+1), 0.d0)
	    chh1=dcmplx(hh(i), 0.d0)
	    chh2=dcmplx(hh(i+1), 0.d0)
	    cvel1=dcmplx(vel(i), 0.d0)*cdsqrt(cr1+cr2*ci1*chh1)
	    cvel2=dcmplx(vel(i+1), 0.d0)*cdsqrt(cr1+cr2*ci1*chh2)
	    calph=(crho1*cvel1)/(crho2*cvel2)
	    ckk=dcmplx(omega)/cvel1
	    cmatrix_t(i,1,1)=cr1/cr2*(cr1+calph)
     *	                        *cdexp(ci1*ckk*cthickl(i))
	    cmatrix_t(i,1,2)=cr1/cr2*(cr1-calph)
     *	                        *cdexp(-ci1*ckk*cthickl(i))
	    cmatrix_t(i,2,1)=cr1/cr2*(cr1-calph)
     *	                        *cdexp(ci1*ckk*cthickl(i))
	    cmatrix_t(i,2,2)=cr1/cr2*(cr1+calph)
     *	                        *cdexp(-ci1*ckk*cthickl(i))
 400  continue
c
c
c
c
  777 return
c
c
      end
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   M A T R I X _ Q         **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine matrix_q(nolayer, cmatrix_t, cmatrix_q)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  cmatrix_t(nlayer-1,2,2), cmatrix_q(nlayer-1,2,2)
	dimension  cmtx_dummy(2,2), cmtx_tempo(2,2)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Response of Amplitude of Multi-Layer 
c----------------------------------------------------------------------
c
c
	cr1=dcmplx(1.d0, 0.d0)
	cr2=dcmplx(2.d0, 0.d0)
	ci1=dcmplx(0.d0, 1.d0)
c
c
      do 100 i=1, 2
	    do 200 j=1,2
	      cmatrix_q(nolayer-1,i,j)=dcmplx(0.d0,0.d0)
	      cmtx_dummy(i,j)=dcmplx(0.d0,0.d0)
	      cmtx_tempo(i,j)=dcmplx(0.d0,0.d0)
  200     continue		    
  100 continue
	cmtx_dummy(1,1)=cr1
	cmtx_dummy(2,2)=cr1
c
c
      do 300 i=1, nolayer-1
	    do 400 j=1,2
	      do 500 k=1,2
	        do 600 l=1,2
                 cmtx_tempo(j,k)=cmtx_tempo(j,k)
     *		                  +cmatrix_t(i,j,l)*cmtx_dummy(l,k)
  600         continue
  500	      continue
  400	    continue
	    do 700 j=1,2
	      do 800 k=1,2
	        cmtx_dummy(j,k)=cmtx_tempo(j,k)
	        cmatrix_q(i,j,k)=cmtx_tempo(j,k)
	        cmtx_tempo(j,k)=dcmplx(0.d0,0.d0)
  800	      continue
  700	    continue
  300 continue
c
c
  777 return
c
c
      end
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   M A T R I X _ R         **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine matrix_r(nolayer, cmatrix_q, cmatrix_r)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  cmatrix_q(nlayer-1,2,2), cmatrix_r(nlayer-1,2,2)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Response of Amplitude of Multi-Layer 
c----------------------------------------------------------------------
c
c
c
c
      do 100 i=1, 2
	    do 200 j=1,2
	      cmatrix_r(nolayer-1,i,j)=0.d0
  200     continue		    
  100 continue
c
c
	determ=cmatrix_q(nolayer-1,1,1)*cmatrix_q(nolayer-1,2,2)
     *      -cmatrix_q(nolayer-1,1,2)*cmatrix_q(nolayer-1,2,1)
	cmatrix_r(nolayer-1,1,1)= cmatrix_q(nolayer-1,2,2)/determ
	cmatrix_r(nolayer-1,1,2)=-cmatrix_q(nolayer-1,1,2)/determ
	cmatrix_r(nolayer-1,2,1)=-cmatrix_q(nolayer-1,2,1)/determ
	cmatrix_r(nolayer-1,2,2)= cmatrix_q(nolayer-1,1,1)/determ
c
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   O P T _ M S G           **********
c*                                                                     *
c***********************************************************************
c
c
	subroutine opt_msg(thickl,rho,vel,hh)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  thickl(nlayer), rho(nlayer), vel(nlayer), hh(nlayer)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Response of Amplitude of Multi-Layer 
c----------------------------------------------------------------------
c
c
	write (12,1200) 
 1200	format(' / No., H, rho, Vels, hh, Z[(i)-(i+1)],N.Period /')
c

	do 100 i=1,nlayer
	   period_nat=4.d0*thickl(i)/vel(i)
	   zzz=1.d0
	   if (i .ne. nlayer) then
	     zzz=(rho(i)*vel(i))/(rho(i+1)*vel(i+1))
	   end if
         write (12,1210) i, thickl(i), rho(i), vel(i), hh(i), zzz,
     *				  period_nat
 1210	   format(i3,6e15.7)
  100	continue
c
c
	write (12,1220) 
 1220	format(' Freq., Period, omg,
     *         A1/An, AB1/ABn, AccB, AccS')
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   O P T _ D A T           **********
c*                                                                     *
c***********************************************************************
c
c
	subroutine opt_dat(omega,thickl,vel,cmatrix_r, accb)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /dainf/ ndat, inpw
      common /tcinf/ tint
	common /flinf/ band, offhigh, offlow, ifinp
	common /niinf/ gammanew, betanew
	common /lyinf/ nlayer
c
	dimension  thickl(nlayer), vel(nlayer)
	dimension  cmatrix_r(nlayer-1,2,2)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Response of Amplitude of Multi-Layer 
c----------------------------------------------------------------------
c
c
	cr1=dcmplx(1.d0, 0.d0)
	cr2=dcmplx(2.d0, 0.d0)
	ci1=dcmplx(0.d0, 1.d0)
c
	omega_nat1=2.d0*pi/(4.d0*thickl(1)/vel(1))
	freq=omega/(2.d0*pi)
	period=2.d0*pi/omega
c
	cbnan=(cmatrix_r(nlayer-1,1,1)-cmatrix_r(nlayer-1,2,1))/
     *      (cmatrix_r(nlayer-1,2,2)-cmatrix_r(nlayer-1,1,2))
c
	ca1an=cmatrix_r(nlayer-1,1,1)+cmatrix_r(nlayer-1,1,2)*cbnan
	cab1abn=(cr2*ca1an)/(cr1+cbnan)
     	a1an=cdabs(ca1an)
	ab1abn=cdabs(cab1abn)
      accs=a1an*accb
c
	write (12,1200) freq, period, omega,
     *	            a1an, ab1abn, accb, accs                 
 1200	format(6(e15.7,','), e15.7)
c
c
  777 return
c
c
      end
c
c
